'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var chunkHQ6QY5OO_js = require('./chunk-HQ6QY5OO.js');

// src/logic/isArrayEmpty.ts
function isArrayEmpty(arr) {
  for (const name in arr) {
    if (Number.isNaN(+name))
      return true;
    return false;
  }
  return true;
}

// src/logic/Table.ts
function getExtendsPropertyDescriptors(data) {
  if (data === null || typeof data !== "object")
    return;
  if (chunkHQ6QY5OO_js.isBuffer(data))
    return chunkHQ6QY5OO_js.getOwnDescriptorsBuffer(data);
  if (chunkHQ6QY5OO_js.isCollection(data))
    return chunkHQ6QY5OO_js.getOwnDescriptorsCollection(data);
  if (chunkHQ6QY5OO_js.isDataView(data))
    return chunkHQ6QY5OO_js.getOwnDescriptorsDataView(data);
  if (chunkHQ6QY5OO_js.isRegExp(data))
    return chunkHQ6QY5OO_js.getOwnDescriptorsRegExp(data);
  if (chunkHQ6QY5OO_js.isTypedArray(data))
    return chunkHQ6QY5OO_js.getOwnDescriptorsTypedArray(data);
  return void 0;
}
function getDescriptors(data) {
  return Object.assign(
    chunkHQ6QY5OO_js.getOwnDescriptorsIn(data),
    Object.getOwnPropertyDescriptors(data),
    getExtendsPropertyDescriptors(data)
  );
}
function Table(data) {
  const table = {};
  const nameCols = /* @__PURE__ */ new Set();
  chunkHQ6QY5OO_js.entries(getDescriptors(data)).forEach(([name, meta]) => {
    name = name.toString();
    const { value } = meta;
    let isArray;
    if (value !== null && typeof value === "object" && (!(isArray = Array.isArray(value)) || !isArrayEmpty(value))) {
      const row = table[name] = {};
      chunkHQ6QY5OO_js.entries(getDescriptors(value)).forEach(([propName, propMeta]) => {
        if (isArray && propName === "length")
          return;
        propName = propName.toString();
        nameCols.add(propName);
        row[propName] = chunkHQ6QY5OO_js.createPreviewValue(propMeta.value);
      });
    } else {
      nameCols.add("Values");
      table[name] = {
        Values: chunkHQ6QY5OO_js.createPreviewValue(value)
      };
    }
  });
  return {
    table,
    cols: Array.from(nameCols.values())
  };
}

exports.Table = Table;
